﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Windows.Forms;
using System.Drawing;

namespace M51
{

    class Tower
    {
        private List<Block> Results;
        private string Path;
        private int Width, Lenght;
        private string Type;


        public Tower(string path)
        {
            this.Path = path;
            Results = new List<Block>();

            StreamReader reader = new StreamReader(path);
            string input = reader.ReadToEnd();
            reader.Close();
            Generate(input);
        }

        public void PrintResult(ListBox lb)
        {
            lb.Items.Add("--Pro soubor: " + Path + "--");
            foreach (Block s in Results)
            {
                lb.Items.Add(s.ToString());
            }
            lb.Items.Add("--Konec souboru: "+ Path + "--");
        }

        private int[] FindValue(int[,,] arr,int value,int z)
        {
            for (int i = 0; i < arr.GetLength(0); i++)
            {
                for (int j = 0; j < arr.GetLength(1); j++)
                {
                    if (arr[i, j, z] == value) return (new int[] { i,j});
                }
            }
            return null;
        }


        private int[] FindValueInBounds(int[, ,] arr, int value, int z)
        {

            for (int i = 0; i < arr.GetLength(0); i++)
            {
                if(arr[i,0,z] == value) return (new int[]{i,0});
                else if(arr[i,arr.GetLength(1) - 1,z] == value) return (new int[]{i,arr.GetLength(1) - 1});
            }

            for (int i = 0; i < arr.GetLength(1); i++)
            {
                if (arr[0,i, z] == value) return (new int[] { 0,i });
                else if (arr[arr.GetLength(0) - 1,i, z] == value) return (new int[] {  arr.GetLength(0) - 1,i });
            }
            return null;
        }

        private bool MatchColors(int[,,] arr, int l, int w, int z)
        {

            return true;
        }

        private void Generate(string input)
        {
            #region Preparation
            input = input.Replace('\r','\n');
            input = input.Replace("\n\n","\n");
            for (int k = 0; k < 4; k++) input = input.Replace("  ", " ");
            string[] lines = input.Split('\n');

            string[] first = lines[0].Split(' ');
            this.Width = Int32.Parse(first[0]);
            this.Lenght = Int32.Parse(first[1]);
            this.Type = first[2];

            StreamWriter writer = new StreamWriter(Path.Replace(".in", ".51"));
            writer.WriteLine(this.Lenght + " " + this.Width + " " + this.Type);
            writer.Close();

            List<Block> AvailableBlocks = new List<Block>();

            for (int i = 1; i < lines.Count() - 1; i++)
            {
                lines[i] = lines[i].Replace("\t"," ");
                string[] ss = lines[i].Split(' ');
                int w = 0, l = 0;
                w = Int32.Parse(ss[1].Split(new char[] { 'X', 'x' })[0]);
                l = Int32.Parse(ss[1].Split(new char[] { 'X', 'x' })[1]);
                int count = Int32.Parse(ss[2]);

                for (int j = 0; j < count; j++) AvailableBlocks.Add(new Block(w,l,ss[0]));
            }

            int[,,] arr = new int[Lenght,Width,50];

            for (int i = 0; i < Lenght; i++)
            {
                for (int j = 0; j < Width; j++)
                {
                    for (int k = 0; k < 50; k++)
                    {
                        arr[i, j, k] = -1;
                    }
                }
            }
            #endregion


                        int currentfloor = 0;
                        int mainiterations = 0;
                        while (AvailableBlocks.Count > 0 && mainiterations < AvailableBlocks.Count * 2 && currentfloor < 50)
                        {
                            mainiterations++;
                            int[] freeindex = null;
                            while(freeindex == null)
                            {
                                if(Type == "P" || Type== "PB")freeindex = FindValue(arr, -1, currentfloor);   ///////Najde volne misto v poli
                                else freeindex = FindValueInBounds(arr,-1,currentfloor);
                                if (freeindex == null) currentfloor++;
                            }
                            if (currentfloor > 48) break;

                            ////// vybere kosticku
                            bool fail = false;
                            int index = -1;
                            int rot = 0;

                            if (AvailableBlocks.Count > 0)
                            {
                                do
                                {
                                    index++;
                                    fail = false;

                                    List<Point> changedpoints = new List<Point>();
                                    for (rot = 0; rot < 3; rot++) //Zkousi ji posadit ve vsech moznych rotacich
                                    {
                                        int W = AvailableBlocks[index].WidthForRot(rot);
                                        int L = AvailableBlocks[index].LenghtForRot(rot);

                                        #region Filling array
                                        ///Vyplnovani pole na sirku
                                        if (W > 0)
                                        {
                                            for (int w = 0; w < W; w++)
                                            {
                                                if (arr.GetLength(1) <= freeindex[1] + w || arr[freeindex[0], freeindex[1] + w, currentfloor] != -1)
                                                { fail = true; break; }
                                                else
                                                {
                                                    arr[freeindex[0], freeindex[1] + w, currentfloor] = index + Results.Count;
                                                    changedpoints.Add(new Point(freeindex[0], freeindex[1] + w));

                                                    if (!MatchColors(arr, freeindex[0], freeindex[1] + w, currentfloor)) fail = true; 
                                                }
                                            }
                                        }
                                        else
                                        {
                                            for (int w = 0; w > W; w--)
                                            {
                                                if (freeindex[1] + w < 0 || arr[freeindex[0], freeindex[1] + w, currentfloor] != -1) 
                                                { fail = true; break; }
                                                else
                                                {
                                                    arr[freeindex[0], freeindex[1] + w, currentfloor] = index + Results.Count;
                                                    changedpoints.Add(new Point(freeindex[0], freeindex[1] + w));

                                                    if (!MatchColors(arr, freeindex[0], freeindex[1] + w, currentfloor)) fail = true; 
                                                }
                                            }
                                        }
                                        //Vyplnovani pole na sirku

                                        ///Vyplnovani pole na delku
                                        if (!fail)
                                        {
                                            if (L > 0)
                                            {
                                                for (int l = 1; l < L; l++)
                                                {
                                                    if (arr.GetLength(0) <= freeindex[0] + l || arr[freeindex[0] + l, freeindex[1], currentfloor] != -1)
                                                    { fail = true; break; }
                                                    else
                                                    {
                                                        arr[freeindex[0] + l, freeindex[1], currentfloor] = index + Results.Count;
                                                        changedpoints.Add(new Point(freeindex[0] + l, freeindex[1]));

                                                        if (!MatchColors(arr, freeindex[0] + l, freeindex[1], currentfloor)) fail = true; 
                                                    }
                                                }
                                            }
                                            else
                                            {
                                                for (int l = 1; l > L; l--)
                                                {
                                                    if (freeindex[0] + l < 0 || arr[freeindex[0] + l, freeindex[1], currentfloor] != -1) 
                                                    { fail = true; break; }
                                                    else
                                                    {
                                                        arr[freeindex[0] + l, freeindex[1], currentfloor] = index + Results.Count;
                                                        changedpoints.Add(new Point(freeindex[0] + l, freeindex[1]));

                                                        if (!MatchColors(arr, freeindex[0] + l, freeindex[1], currentfloor)) fail = true; 
                                                    }
                                                }
                                            }
                                        }
                                        //Vyplnovani pole na delku   
                                        #endregion

                                        //V pripade problemu navrati zmeny
                                        if (fail)
                                        {
                                            for (int i = 0; i < changedpoints.Count; i++) arr[changedpoints[i].X, changedpoints[i].Y, currentfloor] = -1;
                                        }
                                        else
                                            break;
                                        //V pripade problemu navrati zmeny


                                    }



                                } while ( fail && index < (AvailableBlocks.Count - 2)); // Cyklus pokracuje v pripade selhani=chybe a pri nedokonceni prochazeni vsech kosticek
                                //////Vybere kosticku

                            }

                            if (rot < 3) //Pouze pokud kosticka sedi
                            {
                                //ulozi informace do kosticky
                                {
                                    AvailableBlocks[index].Final.rot = rot;
                                    AvailableBlocks[index].Final.x = freeindex[0];
                                    AvailableBlocks[index].Final.y = freeindex[1];
                                    AvailableBlocks[index].Final.floor = currentfloor;
                                    Results.Add(AvailableBlocks[index]);

                                    AvailableBlocks.RemoveAt(index);
                                }
                                //ulozi informace do kosticky

                                //Prubezne ulozi novou kosticku
                                if (Results.Count > 0)
                                {
                                    writer = new StreamWriter(Path.Replace(".in", ".51"), true);
                                    writer.WriteLine(Results[Results.Count - 1].ToString());
                                    writer.Close();
                                }
                                //Prubezne ulozi novou kosticku
                            }
                            else break;
                        }

        }


    }
}
